/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: controller.h,v 1.5 2004/07/28 21:15:42 cheako Exp $
 *
 * Description: This file handles joystick input.
 */

#ifndef _CONTROLLER_H
#define _CONTROLLER_H

#ifdef HAVE_FEATURES_H
#include <features.h>
#endif				/* HAVE_FEATRES_H */

struct Controller {
    char *name, *fullname;
    unsigned int joypad[2];
    unsigned int joypadd[2];
    unsigned int coinslot;
    unsigned int dipswitches;
    void (*InitJoystick) (int stick);
    void (*HandleJoystick) (int stick);
    void (*ShutdownJoystick) (int stick);
};

/* the currently selected controller */
extern struct Controller *controller;

/* table of controllers, terminated by { 0, ... } */
extern struct Controller controllers[];

#endif /* _CONTROLLER_H */
