/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: emulator.c,v 1.6 2004/07/30 02:54:47 cheako Exp $
 *
 * Description: Emulator core choses and links in real emulator.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */

#include "emulator.h"
#include "emulator_x86.h"
#include "emulator_c.h"

/* Common vars */
signed int	CTNI;		/* Cycles to next interrupt */
signed int	INRET;		/* Input data return value */
unsigned int	VRAMPTR;	/* address to read/write video memory */

struct Emulator emulators[] = {
#ifdef HAVE_X86
	{ "x86", "x86 dynamic recompiling assembly emulator (fast)", 0, 0, 0, 0,
	 InitMapperSubsystemX86, InitMemoryX86, FreeMemoryX86, DoNMIX86, 
	 StartX86 },
#endif
	{"c", "C interpreter emulator", 0, 0, 0, 0,
	 InitMapperSubsystemC, InitMemoryC, FreeMemoryC, DoNMIC, StartC },
	{ 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
}, *emulator;
