/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: emulator.h,v 1.6 2004/07/30 04:25:03 cheako Exp $
 *
 * Description: Defines emulator routing routines.
 */

#ifndef _EMULATOR_H_
#define _EMULATOR_H_

/* Common defs */
#define REG1 ((unsigned char *)(emulator->RAM+0x2000))
extern signed int	INRET;      /* Input data return value */
extern signed int	CTNI;       /* Cycles to next interrupt */
extern unsigned int	VRAMPTR;    /* address to read/write video memory */

struct Emulator {
	char *name, *fullname;
	void **Mapper;
	void **MapperInit;
	unsigned char* ROM;
	unsigned char* RAM;
	void (*InitMapperSubsystem)(void);
	void (*InitMemory)(void);
	void (*FreeMemory)(void);
	int (*DoNMI)(void);
	void (*Start)(void);
};

/* the currently selected emulator */
extern struct Emulator *emulator;

/* table of emulators, terminated by { 0, ... } */
extern struct Emulator emulators[];

#endif /* _EMULATOR_H_ */
