/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: emulator_c_iface.h,v 1.3 2004/07/28 21:15:42 cheako Exp $
 *
 * Description: This file handles joystick input for SDL.
 */

#ifndef _EMULATOR_C_IFACE_H
#define _EMULATOR_C_IFACE_H

#include "globals.h"
#include "types.h"

#define INT_NONE  0            /* No interrupt required      */
#define INT_IRQ   1            /* Standard IRQ interrupt     */
#define INT_NMI   2            /* Non-maskable interrupt     */
#define INT_QUIT  3            /* Exit the emulation         */ 

uint8_t mem_read(uint32_t);
void mem_write(uint32_t, uint8_t);

extern uint8_t reg_A, reg_P, reg_X, reg_Y, reg_S;
extern uint32_t reg_PC;
extern uint8_t *ram, *stack_page;


#endif
