/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: globals.h,v 1.46 2004/05/13 11:10:31 cheako Exp $
 *
 * Description: A bunch of global variables
 */

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include "consts.h"

extern unsigned char	*ROM_BASE;
extern int       MAPPERNUMBER;
extern void	(*drawimage)(int);

/* Global Variables */
int	mask;                       /* file creation mask */
extern int      swap_inputs;
extern int	desync;
extern unsigned short int hscroll[], vscroll[];
extern unsigned char	 linereg[];
extern unsigned char	 spriteram[];
extern unsigned char	 VRAM[];
extern unsigned int	*NES_palette;
extern unsigned char	*MAPTABLE[];
extern unsigned int	 hvmirror;
extern unsigned int	 nomirror;
extern unsigned int	 osmirror;
extern unsigned int	 CLOCK;
extern unsigned int	 bpp;
extern unsigned int	 bpu;
extern unsigned int	 bitmap_pad;
extern unsigned int	 depth;
extern unsigned int      bytes_per_line;
extern int	magstep;
extern int      fullscreen;
extern int	xpan, ypan;
extern unsigned int	 lsb_first;
extern unsigned int	 lsn_first;
extern unsigned int	 pix_swab;
extern unsigned int	 frameskip;
extern unsigned int	 vline;
extern unsigned int	 vscan;
extern unsigned int	 vwrap;
extern unsigned int	 scanpage;
extern unsigned int      scanlines;
extern unsigned char	 vscrollreg;
extern unsigned char	 hscrollreg;
extern char	*rfb;
extern char	*fb;
extern int	*palette, *palette2;
extern char	tuxnesdir[];
extern char *basefilename;  /* filename without extension */
extern char	*jsdevice[2];
extern struct js_nesmap {
  unsigned char button[JS_MAX_BUTTONS];
  struct {
    unsigned char neg;
    unsigned char pos;
  } axis[JS_MAX_AXES];
} js_nesmaps[2];
extern unsigned char js_mapoption[JS_MAX_NES_BUTTONS];
extern unsigned char js_axismeso[2][JS_MAX_AXES];
extern unsigned char js_usermapped2button[2][2];

/* Flags */
extern int      verbose;
extern int	disassemble;
extern int	ignorebadinstr;
extern int	unisystem;
extern int	halfspeed;
extern int      doublespeed;
extern int	indexedcolor;

/* renderer_x11.c and controller.c shared */
/* FIXME */
extern int     debug_bgoff;
extern int     debug_spritesoff;
extern int     debug_switchtable;
unsigned char   displaycachevalid[tilecachedepth][3840];
unsigned char   bitplanecachevalid[tilecachedepth][3840];
extern int width, height;
extern unsigned char *keystate[32];
extern unsigned char needsredraw, redrawbackground, redrawall;
void     SaveScreenshotX11(void);

/* configuration variables */
struct configvars
{
  char *tuxnesdir;  /* the home directory */
  char *savegamedir; /* directory for saved game files */
  char *screenshotdir;  /* directory for screenshot files */
  char *audiodevice;   /* audio device */
  char *jsdevice;      /* joystick device */
};
extern struct configvars config;

extern void quit(void);

#endif /* _GLOBALS_H_ */
