/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: mapper.h,v 1.10 2003/12/05 23:05:38 cheako Exp $
 *
 * Description: Important constants related to the mapper functionality and
 * ASM linkage.
 */

#include "consts.h"

/* #define DEBUG_MAPPER 1 */

char MapperName[MAXMAPPER + 1][30];

void init_none(void);
void init_100in1(void);
void init_aorom(void);
void init_camerica(void);
void init_clrdrms(void);
void init_cnrom(void);
void init_cprom(void);
void init_fme7(void);
void init_g101(void);
void init_gnrom(void);
void init_irem_74hc161_32(void);
void init_mmc1(void);
void init_mmc2(void);
void init_mmc3(void);
void init_mmc4(void);
void init_mmc5(void);
void init_namcot106(void);
void init_nina7(void);
void init_sunsoft4(void);
void init_supervision(void);
void init_taito_tc0190(void);
void init_tengen_rambo1(void);
void init_unrom(void);
void init_vrc2_a(void);
void init_vrc2_b(void);
void init_vs(void);

void m100in1(int, int);
void aorom(int, int);
void camerica(int, int);
void clrdrms(int, int);
void cnrom(int, int);
void cprom(int, int);
void (*drawimage) (int);
void fme7(int, int);
void g101(int, int);
void gnrom(int, int);
void irem_74hc161_32(int, int);
void mmc1(int, int);
void mmc2(int, int);
void mmc3(int, int);
void mmc4(int, int);
void mmc5(int, int);
void namcot106(int, int);
void nina7(int, int);
void sunsoft4(int, int);
void supervision(int, int);
void taito_tc0190(int, int);
void tengen_rambo1(int, int);
void unrom(int, int);
void vrc2_a(int, int);
void vrc2_b(int, int);
void vs(int, int);
void mnone(void);

int MapRom(int, unsigned, unsigned);
