/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: sound.h,v 1.12 2004/08/23 23:54:58 cheako Exp $
 *
 * Description: sound interface
 */

/* NTSC frequency multiplier */
#define BASE_FREQ 111860.78
/* NTSC sound update rate (== vertical retrace rate) */
#define UPDATE_FREQ 60.0
#define INTERNAL_FREQ 60.0
/* PAL frequency multiplier */
/* #define BASE_FREQ 110840.47 */
/* PAL sound update rate (== vertical retrace rate) */
/* #define UPDATE_FREQ 50.0 */

#define SND_BUF_SIZE         20000
#define SAMPLES_PER_SECOND   44100.0f
#define STEPS_PER_VSYNC      BASE_FREQ
#define CYCLES_PER_SAMPLE    41 /* 44100Hz */

/* exports */
int InitAudioCore(int argc, char **argv);
void ProgressiveSoundUpdate(char new_frame);

extern int audiofd;
extern int buf_size;

extern void		SoundEvent(long addr, unsigned char value);
extern char     	SoundGetLengthReg(void);

extern unsigned int  samples_per_vsync;
extern unsigned char *audio_buffer;

/* lookup table for 12bit->Mu-Law sample conversion */
extern unsigned char ulaw [0x4000];
