/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: sounder.c,v 1.4 2004/08/23 23:54:58 cheako Exp $
 *
 * Description: Choses and links in the real sound output code.
 */

#include "sounder.h"
#include "sounder_oss.h"
#include "sounder_sdl.h"

/* global sound parameters */
struct SoundConfig sound_config = {
     /* char *audiofile */
     "/dev/dsp",
     /* int        audiorate */
     44100,
     /* int        audiostereo */
     0,
     /* float        max_sound_delay */
     0.33,
     /* int        reverb */
     0,
};

/* table of sample formats, terminated by { 0, ... } */
struct SampleFormat SampleFormatsMute[] = {
     { "8",    "No sound output format, fake it.",
       8, 0, 0, 0 },
     { 0, 0, 0, 0, 0, 0 }
};

struct Sounder sounders[] = {
    {"oss", "OSS driver", "8", SampleFormatsOSS, InitAudioOSS,
	 UpdateAudioOSS, ShutdownAudioOSS},
    {"mute", "Muted audio", "8", SampleFormatsMute, InitAudioMute,
	 UpdateAudioMute, ShutdownAudioMute },
#ifdef HAVE_LIBSDL
    {"sdl", "SDL driver", "8", SampleFormatsSDL, InitAudioSDL,
	 UpdateAudioSDL, ShutdownAudioSDL},
#endif /* HAVE_LIBSDL */
    {0, 0, 0, 0, 0 }
}, *sounder = 0;

/* the currently selected sample format */
struct SampleFormat *sample_format = 0;

int InitAudioMute(int argc, char **argv)
{
   return (0);
}

void UpdateAudioMute(void)
{
}

void ShutdownAudioMute(void)
{
}
