/*
 * This file is part of the TuxNES project codebase.
 *
 * Please see the README and COPYING files for more information regarding
 * this project.
 *
 * $Id: sounder.h,v 1.3 2004/08/23 23:54:58 cheako Exp $
 *
 * Description: sound output interface.
 */

struct SampleFormat {
     char *name, *fullname;
     int number;
     int bytes_per;
     int _signed;
     int _endian; /* 0 = auto, 1 = LE, 2 = BE */
};

struct Sounder {
	char *name, *fullname, *sample_format_default;
	struct SampleFormat *sample_formats;
	int (*InitAudio)(int argc, char **argv);
	void (*UpdateAudio)(void);
	void (*ShutdownAudio)(void);
};

/* global sound parameters */
extern struct SoundConfig {
     char	*audiofile;
     int	audiorate;
     int	audiostereo;
     float	max_sound_delay;
     int	reverb;
} sound_config;

/* the currently selected sounder */
extern struct Sounder *sounder;

/* table of sounders, terminated by { 0, ... } */
extern struct Sounder sounders[];

/* the currently selected sample format */
extern struct SampleFormat *sample_format;

extern int		InitAudioMute(int argc, char **argv);
extern void		UpdateAudioMute(void);
extern void		ShutdownAudioMute(void);
